import lia.Monitor.monitor.*;

import java.io.*;
import java.util.*;
import java.net.InetAddress;


public class queueMon extends cmdExec implements  MonitoringModule,BatchInt {


String[] tmetric;
String[] queueMetric={"TotalJobs", "RunningJobs", "WaitingJobs", "WorstResponseTime",
                      "EstimatedResponseTime", "FreeCPUs", "Status"};
int size = queueMetric.length;

String [] ijobs;
  
String args ;
static public String ModuleName="queueMon";
String[] LSFQueues;
String[] LSFQueuesNames;

boolean condor_is_used=false;
boolean lsf_is_used=false;
boolean pbs_is_used=false;
boolean sge_is_used=false;


public queueMon  () { 
   super( ModuleName );
   info.ResTypes = tmetric;
   System.out.println ( "Start the Interface to Queue Monitoring" );
   isRepetitive = true;
}

public  MonModuleInfo init( MNode Node , String args ) {
    this.Node = Node;

    if ( args != null ) { 
       System.out.println("args: "+args);
       StringTokenizer tz = new StringTokenizer(args,",");
       int k = tz.countTokens();
       tmetric = new String [k];
       ijobs = new String[k];

       for ( int j=0; j < k; j ++ ) {
         String jname = tz.nextToken().trim();
         ijobs[j] = jname;
//         System.out.println("ijobs["+j+"]:"+ijobs[j]);
         if (jname.compareToIgnoreCase("LSF") == 0) {
            System.out.println("LSF is Used in Queue Monitoring");
            lsf_is_used = true;
         } else if (jname.compareToIgnoreCase("CONDOR") == 0) {
                   System.out.println("CONDOR is Used in Queue Monitoring");
                   condor_is_used = true;
                } else if (jname.compareToIgnoreCase("PBS") == 0) {
                          System.out.println("PBS is Used in Queue Monitoring");
                          pbs_is_used = true;
                        } else if (jname.compareToIgnoreCase("SGE") == 0) {
                                 System.out.println("SGE is Used in Queue Monitoring");
                                 sge_is_used = true;
                                }
      }
    }
    info.ResTypes = tmetric;
    this.args = args;

    return info;
}


public Object  doProcess() throws Exception  {
   Vector testV = new Vector();
   if ( condor_is_used )  testV.addAll( collectCondorQueueInfo() );
   if ( lsf_is_used ) {
       LSFQueues = getLSFQueues();
       LSFQueuesNames = new String[LSFQueues.length];

       for (int i=0; i<LSFQueues.length; i++) {
          LSFQueuesNames[i]="LSF_"+LSFQueues[i];
       }
       testV.addAll( collectLSFQueueInfo() );
   }

//   for (int j=0; j<testV.size(); j++) {
//       System.out.println("testV("+j+")="+testV.get(j));
//   }   

   return testV;

}


public MonModuleInfo getInfo(){
        return info;
}


public String[] ResTypes () {
  return tmetric;
}

public String getOsName() { return "linux"; }



// Available LSF Queues
public String[] getLSFQueues() {

   Vector vqueues = new Vector();
   String cmd = LSF_BIN+"bqueues -w";
   BufferedReader buff = procOutput ( cmd );

   try {
      if ( buff == null ) {
         System.out.println ( " Failed  to get the LSF Queues: "+cmd );
         throw new Exception ( " LSF load  output  is null for " + Node.name);
      } 
   } catch (Exception e) {
       System.out.println ("Exception in getLSFQueues() "+e);
   }
   StringTokenizer tz;
   String line;


   try {

// get rid of the header line
   line = buff.readLine();
   if (line == null) {
      System.out.println( "line is null in getLSFQueues().");
      throw new Exception ("Exception in getLSFQueues()");
   }
      for ( ; ;) {
          line = buff.readLine();
          if (line == null) break;
          if (line.equals("")) break;
          tz= new StringTokenizer(line);
          int n = tz.countTokens();
          if (n > 4) {
             String qname = tz.nextToken().trim();
             vqueues.add(qname);
          }
      }
   } catch (Exception e) {
      System.out.println("Exception in getting Queues: "+e);
   }  // end of try block 

   String[] Squeues = new String[vqueues.size()];
   vqueues.toArray(Squeues);
   return Squeues;
}


public Vector collectLSFQueueInfo(){

 Vector queueResults = new Vector();
 int[] Par = new int[3];
 try {
   for (int i=0; i<LSFQueues.length; i++) {

   Result rr = null ;
   rr = new Result(Node.getFarmName(), Node.getClusterName(), LSFQueuesNames[i], ModuleName, queueMetric );
  rr.time = (new Date()).getTime();

     String cmd = LSF_BIN+"bqueues "+LSFQueues[i];
     BufferedReader buff = procOutput ( cmd );

     Par = parseCmdLSF(buff);
     rr.param[0]=Par[0];
     rr.param[1]=Par[1];
     rr.param[2]=Par[2];

     queueResults.add(rr);
//   System.out.println(rr);

   }
 } catch (Exception e) {
   System.out.println("Exception in collectLSFQueueInfo: "+e);
 }

   return queueResults; 
}


public Vector collectCondorQueueInfo(){

 Vector condorQueueResults = new Vector();
 int[] Par = new int[3];
 String cmd;
 BufferedReader buff=null;

 try {
   for (int i=0; i<condorQueues.length; i++) {
       Result rr = null ;
       rr = new Result(Node.getFarmName(), Node.getClusterName(), condorQueueNames[i], ModuleName, queueMetric );
       rr.time = (new Date()).getTime();

       cmd = CONDOR_BIN+"condor_status -total -pool "+condorQueues[i];
       buff=procOutput(cmd);
       if ( buff == null) {
          System.out.println(" Failed to execute cmd: "+cmd+ " in collectCondorQueueInfo.");
          throw new Exception(" Exception in collectCondorQueueInfo.");
       }
        
// param[5] is the FreeCPUs.
       rr.param[5] = parseCmdCondorFreeCPUs(buff);

       cmd = CONDOR_BIN+"condor_q -global -pool "+condorQueues[i];
       if ( (buff=procOutput(cmd)) == null) {
          System.out.println(" Failed to execute cmd: "+cmd+ " in collectCondorQueueInfo.");
          throw new Exception(" Exception in collectCondorQueueInfo.");
       }
       Par = parseCmdCondor(buff); 

       rr.param[0]=Par[0];
       rr.param[1]=Par[1];
       rr.param[2]=Par[2];

       condorQueueResults.add(rr);

   } // loop over all Condor Queues
 } catch (Exception e) {
   System.out.println("Exception in collectCondorQueueInfo(): "+e);
 } finally {
   try {
       if (buff != null) buff.close();
       if (pro != null) pro.destroy();
   } catch (Exception e) {
       System.out.println(" Exception while closing BufferedReader buff "+e);
   }
 }

   return condorQueueResults; 
}




// parseCmdCondorFreeCPUs executes the condor_status -total command
// to calculate the number of Free CPUs in the Condor Queue
public int parseCmdCondorFreeCPUs(BufferedReader buff) throws Exception {
        String line;
// The first five lines will be skipped
// The sixth line contains the useful info
        for (int i=1; i<=5; i++) { 
          line = buff.readLine();
        }

        if ( (line = buff.readLine()) == null) {
           System.out.println(" line is null in parseCmdCondorFreeCPUs");
           throw new Exception (" line is null in parseCmdCondorFreeCPUs");
        }
        StringTokenizer tz = new StringTokenizer(line);
        tz.nextToken().trim();
        String machines = tz.nextToken().trim();
        String owner    = tz.nextToken().trim();
        String claimed  = tz.nextToken().trim();
        String unclaimed= tz.nextToken().trim();
        String matched  = tz.nextToken().trim();
        String preempting= tz.nextToken().trim();

        return Integer.parseInt(unclaimed); 
}

public int[] parseCmdCondor(BufferedReader buff) throws Exception {
       StringTokenizer tz;
       String line;
       int totalJobs = 0;
       int runningJobs=0;
       int idleJobs=0;
       int heldJobs=0;
       int waitingJobs=0;

       while( (line=buff.readLine()) != null) {
         if ( (line.indexOf("idle") !=-1) && (line.indexOf("running") != -1) ) {
            tz = new StringTokenizer ( line ) ;
            String Jobs = tz.nextToken().trim();
            totalJobs += Integer.parseInt(Jobs);
            tz.nextToken();
            String Idle = tz.nextToken().trim();
            idleJobs += Integer.parseInt(Idle);
            tz.nextToken();
            String Running = tz.nextToken().trim();
            runningJobs += Integer.parseInt(Running);
            tz.nextToken();
            String Held = tz.nextToken().trim();
            heldJobs += Integer.parseInt(Held);
         } 
       }
       waitingJobs = idleJobs + heldJobs;
       return new int [] {totalJobs, runningJobs, waitingJobs};
       
}
        

// ParseCmdLSF Will provide three (3) of the expected parameters:
// TotalJobs, RunningJobs and WaitingJobs
public int[] parseCmdLSF(BufferedReader buff) throws Exception {
          String line;
          line = buff.readLine(); // This should get rid of the header line
          line = buff.readLine();

          if ( line == null) {
             System.out.println(" line is null in parseCmdLSF");
             throw new Exception (" line is null in parseCmdLSF");
          }
          StringTokenizer tz= new StringTokenizer(line);
          String jname = tz.nextToken().trim();
          String prio = tz.nextToken().trim();
          String status = tz.nextToken().trim();
          String max = tz.nextToken().trim();
          String jlu = tz.nextToken().trim();
          String jlp = tz.nextToken().trim();
          String jlh = tz.nextToken().trim();
          String njobs = tz.nextToken().trim();
          String pending = tz.nextToken().trim();
          String running = tz.nextToken().trim();
          String suspend = tz.nextToken().trim();

          int totalJobs = new Integer(njobs).intValue();
          int totalPending = new Integer(pending).intValue();
          int totalRunning = new Integer(running).intValue();
          int totalSuspend = new Integer(suspend).intValue();

// waitingJobs are all the jobs in a state different than running
          int waitingJobs = totalPending + totalSuspend;

          buff.close();

          return new int[] {totalJobs, totalRunning, waitingJobs};
}


static public void main ( String [] args ) {

  String host = args[0] ;
  queueMon aa = new queueMon (); 
  String ad = null ;
  try {
    ad = InetAddress.getByName( host ).getHostAddress();
  } catch ( Exception e ) {
    System.out.println ( " Can not get ip for node " + e );
    System.exit(-1);
  }

  MonModuleInfo info = aa.init( new MNode (host ,ad,  null, null), "lsf,condor");



 try  {
  Object bb = aa.doProcess();
 } catch ( Exception e ) {
   System.out.println ( " failed to process " );
 }



}
    
 
}


